<?php

/**
* Delete banner
* @return void
* @param int  $iBanner
*/
function deleteBanner( $iBanner ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aBanners = $oFFS->getData( DB_BANNERS, true );
  $aBannersStats = $oFFS->getData( DB_BANNERS_STATS, true );

  if( isset( $aBanners[$iBanner] ) ){
    if( is_file( DIR_FILES.$aBanners[$iBanner]['sFile'] ) )
      unlink( DIR_FILES.$aBanners[$iBanner]['sFile'] );

    unset( $aBanners[$iBanner] );
    unset( $aBannersStats[$iBanner] );
    
    $oFFS->saveData( DB_BANNERS, $aBanners );
    $oFFS->saveData( DB_BANNERS_STATS, $aBannersStats );
  }
} // end function deleteBanner

/**
* Return list of banners
* @return string
*/
function listBanners( ){
  global $lang;

  $oFFS = FlatFilesSerialize::getInstance( );
  $aBanners = $oFFS->getData( DB_BANNERS, true );
  if( isset( $aBanners ) && is_array( $aBanners ) && count( $aBanners ) > 0 ){
    $content = null;
    $i = 0;
    $aStats = throwBannersStats( );
    $aTypes = $GLOBALS['aBannersTypes'];

    foreach( $aBanners as $iBanner => $aData ){
      $aData['sExt'] = $oFFS->throwExtOfFile( $aData['sFile'] );
      $aData['iViews'] = 0;
      $aData['iClicks'] = 0;
      
      if( isset( $aStats[$aData['iBanner']] ) ){
        $aData['iViews'] = $aStats[$aData['iBanner']]['iViews'];
        $aData['iClicks'] = $aStats[$aData['iBanner']]['iClicks'];
      }

      $content .= '<tr class="l'.( ( $i % 2 ) ? 0: 1 ).'"><td class="id">'.$aData['iBanner'].'</td><td class="details"><div>';
      if( $aData['sExt'] == 'swf' )
        $content .= '<object type="application/x-shockwave-flash" data="'.DIR_FILES.$aData['sFile'].'" width="'.$aData['iWidth'].'" height="'.$aData['iHeight'].'"><param name="bgcolor" value="'.$aData['sColor'].'" /><param name="movie" value="'.DIR_FILES.$aData['sFile'].'" /></object>';
      else
        $content .= '<img src="'.DIR_FILES.$aData['sFile'].'" alt="" style="border:0;'.(isset($aData['iWidth'])?('width:'.$aData['iWidth'].'px;'):null).(isset($aData['iHeight'])?('height:'.$aData['iHeight'].'px;'):null).'" />';
      $content .= '</div><div class="info"><span>'.$lang['Active'].': '.throwYesNoTxt( isset( $aData['iStatus'] ) ? $aData['iStatus'] : 0 ).'</span><span>'.$lang['Position'].': '.( isset( $aData['iPosition'] ) ? $aData['iPosition'] : null ).'</span><span>'.$lang['Clicks'].': '.$aData['iClicks'].'</span><span>'.$lang['Views'].': '.$aData['iViews'].'</span><span>'.$lang['Views_max'].': '.$aData['iMax'].'</span><span>'.$lang['Type'].': '.( isset( $aTypes[$aData['iType']] ) ? $aTypes[$aData['iType']] : null ).'</span>';
      if( isset( $aData['sLink'] ) )
        $content .= '<span>'.$lang['Address'].': <a href="'.$aData['sLink'].'" target="_blank">'.$aData['sLink'].'</a></span>';
      $content .= '</div></td><td class="options"><a href="?p=banners-form&amp;iBanner='.$aData['iBanner'].'"><img src="'.DIR_TEMPLATES.'admin/img/ico_edit.gif" alt="'.$lang['edit'].'" title="'.$lang['edit'].'" /></a> <a href="?p=banners-delete&amp;iBanner='.$aData['iBanner'].'" onclick="return del( );"><img src="'.DIR_TEMPLATES.'admin/img/ico_del.gif" alt="'.$lang['delete'].'" title="'.$lang['delete'].'"/></a></td></tr>';
      $i++;
    } // end for

    if( isset( $content ) )
      return $content;
  }
} // end function listBanners

/**
* Save banner data
* @return int
* @param array  $aForm
*/
function saveBanner( $aForm ){

  $oFFS = FlatFilesSerialize::getInstance( );
  $aBanners = $oFFS->getData( DB_BANNERS, true );
  $aBannersStats = $oFFS->getData( DB_BANNERS_STATS, true );

  if( isset( $_FILES['sFile']['name'] ) && !empty( $_FILES['sFile']['name'] ) ){
    if( preg_match( '/(jpg|gif|jpeg|png|swf)/i', $oFFS->throwExtOfFile( $_FILES['sFile']['name'] ) ) )
      $aForm['sFile'] = $oFFS->uploadFile( $_FILES['sFile'], DIR_FILES );
    else
      return null;
  }

  if( isset( $aForm['iBanner'] ) && is_numeric( $aForm['iBanner'] ) && isset( $aBanners[$aForm['iBanner']] ) ){
    $aForm['sFile'] = $aBanners[$aForm['iBanner']]['sFile'];
  }
  else{
    $aForm['iBanner'] = $oFFS->throwLastId( DB_BANNERS, 'iBanner' ) + 1;
  }

  $aBanners[$aForm['iBanner']] = changeMassTxt( $aForm, '' );
  $aBannersStats[$aForm['iBanner']] = compareArrays( $GLOBALS['aBannersStatsFields'], changeMassTxt( $aForm, '' ) );

  $oFFS->saveData( DB_BANNERS, createBannersArray( $aBanners ) );
  $oFFS->saveData( DB_BANNERS_STATS, $aBannersStats );
  return $aForm['iBanner'];

} // end function saveBanner

/**
* Function creates array to save to file
* @return array
*/
function createBannersArray( $aBanners ){
  if( isset( $aBanners ) ){
    // Sorting array before it will save to file 
    foreach( $aBanners as $iKey => $aValue ){
      $aSort[$iKey][0] = (int) $aValue['iPosition'];
      $aSort[$iKey][1] = $aValue['iBanner'];
    } // end foreach

    if( isset( $aSort ) ){
      sort( $aSort );
      
      foreach( $aSort as $iKey => $aValue ){
        $aSave[$aValue[1]] = compareArrays( $GLOBALS['aBannersFields'], $aBanners[$aValue[1]] );
      } // end foreach

      return $aSave;
    }
  }
} // end function createBannersArray
?>