<?php
/**
* Return banner stats
* @return array
* @param int  $iBanner
*/
function throwBannersStats( $iBanner = null ){
  $oFFS = FlatFilesSerialize::getInstance( );

  $aStats = $oFFS->getData( DB_BANNERS_STATS, true );

  if( isset( $iBanner ) ){
    if( isset( $aStats[$iBanner] ) )
      return $aStats[$iBanner];
  }
  else{
    if( isset( $aStats ) )
      return $aStats;
  }
} // end function throwBannersStats

/**
* Return random banners
* @return array
* @param array  $aTypes
*/
function throwBannersRand( $aTypes = null ){

  $oFFS = FlatFilesSerialize::getInstance( );

  $aBannersRaw = $oFFS->getData( DB_BANNERS, true );
  $aStats = throwBannersStats( );

  if( isset( $aBannersRaw ) && is_array( $aBannersRaw ) && count( $aBannersRaw ) > 0 ){
    foreach( $aBannersRaw as $iBanner => $aValue ){
      if( isset( $aValue['iStatus'] ) && $aValue['iStatus'] == 1 && ( !isset( $aStats[$aValue['iBanner']] ) || isset( $aStats[$aValue['iBanner']] ) && ( $aValue['iMax'] == 0 || ( $aValue['iMax'] > 0 && $aStats[$aValue['iBanner']]['iViews'] < $aValue['iMax'] ) ) ) ){
        $aBanners[$aValue['iType']][] = $aValue;
      }  
    }
  }

  if( isset( $aBanners ) ){
    $iCountTypes = count( $GLOBALS['aBannersTypes'] );
    for( $i = 0; $i < $iCountTypes; $i++ ){
      if( isset( $aBanners[$i] ) && is_array( $aBanners[$i] ) && ( ( isset( $aTypes ) && in_array( $i, $aTypes, true ) ) || !isset( $aTypes ) ) ){
        $iCount = count( $aBanners[$i] );
        if( $iCount > 0 ){
          if( $i == 2 || $i == 3 ){
            $aReturn[$i] = null;
            foreach( $aBanners[$i] as $aData ){
              $aReturn[$i] .= '<li>'.( !empty( $aData['sLink'] ) ? '<a href="'.( defined( 'FRIENDLY_LINKS' ) ? ','.$aData['iBanner'].',banners.html' : '?,'.$aData['iBanner'].',banners' ).'">' : null ).'<img src="'.DIR_FILES.$aData['sFile'].'" alt="" />'.( !empty( $aData['sLink'] ) ? '</a>' : null ).( !empty( $aData['sCaption'] ) ? '<div class="description"><p>'.$aData['sCaption'].'</p></div>' : null ).'</li>';
            }
            $aReturn[$i] = '<div id="slider'.$i.'" class="content-slider">
              <ul>'.$aReturn[$i].'</ul>
              <script type="text/javascript">$("#slider'.$i.'").quickslider({sAnimation:"fade",iPause:4000});</script>
            </div>';
          }
          else{
            $aData = $aBanners[$i][rand( 0, $iCount - 1 )];
            $aData['sExt'] = $oFFS->throwExtOfFile( $aData['sFile'] );
            if( $aData['sExt'] == 'swf' ){
              $aReturn[$i] = '<div id="banner'.$aData['iType'].'" class="bannerFlash"><object type="application/x-shockwave-flash" data="'.DIR_FILES.$aData['sFile'].'" width="'.$aData['iWidth'].'" height="'.$aData['iHeight'].'"><param name="bgcolor" value="'.$aData['sColor'].'" /><param name="movie" value="'.DIR_FILES.$aData['sFile'].'" /></object></div>';
            }
            else{
              $aReturn[$i] = '<div id="banner'.$aData['iType'].'" class="banner">'.( !empty( $aData['sLink'] ) ? '<a href="'.( defined( 'FRIENDLY_LINKS' ) ? ','.$aData['iBanner'].',banners.html' : '?,'.$aData['iBanner'].',banners' ).'">' : null ).'<img src="'.DIR_FILES.$aData['sFile'].'" alt="'.( isset( $aData['sLink'] ) ? $aData['sLink'] : null ).'" title="'.( isset( $aData['sLink'] ) ? $aData['sLink'] : null ).'" />'.( !empty( $aData['sLink'] ) ? '</a>' : null ).'</div>';
            }
            $aId[] = $aData['iBanner'];
          }
        }
      }
    } // end for

    if( isset( $aId ) && is_array( $aId ) )
      changeBannersStats( $aId, 'iViews' );

    if( isset( $aReturn ) && is_array( $aReturn ) ){
      return $aReturn;
    }
  }
} // end function throwBannersRand

/**
* Return banners data
* @return array
* @param int  $iBanner
*/
function throwBanner( $iBanner ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aData = $oFFS->getData( DB_BANNERS, true );
  if( isset( $aData[$iBanner] ) ){
    $aStats = throwBannersStats( $iBanner );
    return array_merge( $aData[$iBanner], (array)$aStats );
  }
} // end function throwBanner

/**
* Redirect to banner link
* @return void
* @param int  $iBanner
*/
function goToBannerLink( $iBanner ){
  $aData = throwBanner( $iBanner );
  if( isset( $aData ) && is_array( $aData ) && !empty( $aData['sLink'] ) ){
    changeBannersStats( Array( $iBanner ), 'iClicks' );
    header( "Location: ".$aData['sLink'] );
    exit;
  }
} // end function goToBannerLink

/**
* Change banners stats
* @return void
* @param array  $aId
* @param string $sIndex
*/
function changeBannersStats( $aId, $sIndex ){
  $oFFS = FlatFilesSerialize::getInstance( );
  $aStats = throwBannersStats( );
  foreach( $aId as $iKey => $iBanner ){
    if( isset( $aStats[$iBanner] ) ){
      $aStats[$iBanner][$sIndex]++;
    }
    else{
      $aStats[$iBanner]['iBanner'] = $iBanner;
      $aStats[$iBanner]['iClicks'] = 0;
      $aStats[$iBanner]['iViews'] = 0;
    }
  } // end foreach

  $oFFS->saveData( DB_BANNERS_STATS, $aStats );
} // end function changeBannersStats
?>